unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, uJJMgt;

type
  TForm1 = class(TForm)
    memMsg: TMemo;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FJJMgt: TJJMgt; // Ҫд롣д uJJMgt
    procedure DispMsg(AMsg: string);
    procedure ThreadDispMsg(AMsg: string);
    procedure OnMgtStatusTing(Sender: TJJMgt; AStatus: TMgtStatus);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  FJJMgt.StartWork;
  Button1.Enabled := false;
end;

procedure TForm1.DispMsg(AMsg: string);
begin
  memMsg.Lines.Add(AMsg);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FJJMgt := TJJMgt.Create;
  FJJMgt.OnMsg := Self.ThreadDispMsg;
  FJJMgt.OnMgtStatus := Self.OnMgtStatusTing;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FJJMgt.Free;
end;

procedure TForm1.OnMgtStatusTing(Sender: TJJMgt; AStatus: TMgtStatus);
begin
  if AStatus = mtOK then
  begin

    TThread.Synchronize(nil,
      procedure
      begin
        Button1.Enabled := true;
      end);

  end;

end;

procedure TForm1.ThreadDispMsg(AMsg: string);
begin
{$I SyncDispMsg.inc}
  // дƻ IDE Զ깦
  // ַһ¡
end;

end.
