unit uSimpleBase;

interface

type
  TOnMsg = procedure(AMsg: string) of object;

  TSimpleBase = class(TObject)
  private
  protected
    procedure DoOnMsg(AMsg: string); virtual;
    procedure OnDispMsgTing(AMsg: string); virtual;
    procedure DispMsg(AMsg: string); virtual;
  public
    OnMsg: TOnMsg;
  end;

implementation

{ TSimpleBase }

procedure TSimpleBase.OnDispMsgTing(AMsg: string);
begin
  DoOnMsg(AMsg);
end;

procedure TSimpleBase.DispMsg(AMsg: string);
begin
  DoOnMsg(AMsg);
end;

procedure TSimpleBase.DoOnMsg(AMsg: string);
begin
  if Assigned(OnMsg) then
    OnMsg(AMsg);
end;

end.
