unit uJJApple;

interface

uses
  uSimpleList, System.SysUtils, System.Classes;

type

  TJJApple = class
  public
    constructor Create;
    destructor Destroy; override;
    function ToDetail: string;
  public
    Param: integer;
    Worked: boolean; // 
    Selected: boolean; // ѡУ
    Sum: integer;
    Index: integer;
  end;

  TJJAppleList = class(TClassSimpleList<TJJApple>)
  public
    procedure Init(ACount: integer);
    function ToText: string;
    function GetUnSelectApple: TJJApple;
  end;

implementation

{ TJJApple }

constructor TJJApple.Create;
begin
  inherited;
  Worked := false;
  Selected := false;
end;

destructor TJJApple.Destroy;
begin

  inherited;
end;

function TJJApple.ToDetail: string;
const
  CA_BooleanStr: array [boolean] of string = ('δ', 'Ѵ');
begin
  Result := 'Ϣ:' + 'Index:' + intTostr(index) + ',Param:' + intTostr(Param) + ',Sum:' + intTostr(Sum) + ',״̬:' +
    CA_BooleanStr[Worked];
end;

{ TJJAppleList }

function TJJAppleList.GetUnSelectApple: TJJApple;
var
  J: TJJApple;
begin
  Result := nil;
  for J in self do
  begin
    if not J.Selected then
    begin
      Result := J;
      exit;
    end;
  end;
end;

procedure TJJAppleList.Init(ACount: integer);
var
  Q: TJJApple;
  i: integer;
begin

  for i := count to ACount - 1 do
  begin
    Q := AddNewOne;
    Q.Index := i;
    Q.Param := i + 100;
  end;

  for Q in self do
  begin
    Q.Sum := 0;
    Q.Selected := false;
    Q.Worked := false;
  end;

end;

function TJJAppleList.ToText: string;
var
  L: TStringList;
  Q: TJJApple;
begin
  L := TStringList.Create;
  try

    for Q in self do
    begin
      L.Add(Q.ToDetail);
    end;

    Result := Trim(L.Text);

  finally
    L.Free;
  end;

end;

end.
